--Data Type Demonstration

--********************************************************


--#1

	--Explain the difference between the two statements
	--Run one at a time

	DECLARE @int1 INT
	SET @int1 = 444444444
	PRINT @int1

	DECLARE @int SMALLINT
	SET @int = 444444444
	PRINT @int



--*************************************************

--#2
	--Decimal Demo
	--Run one at a time

	DECLARE @amount0 AS DECIMAL(4, 0)
	SET @amount0 = 4
	PRINT @amount0

	DECLARE @amount1 AS DECIMAL(4, 1)
	SET @amount1 = 4
	PRINT @amount1


	DECLARE @amount2 AS DECIMAL(4, 2)
	SET @amount2 = 4
	PRINT @amount2

	DECLARE @amount3 AS DECIMAL(4, 3)
	SET @amount3 = 4
	PRINT @amount3

	--Also use 
	----43
	----0.888
	DECLARE @amount4 AS DECIMAL(4, 3)
	SET @amount4 = 4333
	PRINT @amount4

	--Run the next two at the same time
	DECLARE @amount5 AS DECIMAL(4, 3)
	SET @amount5 = 0.887777
	PRINT @amount5


	DECLARE @amount6 AS DECIMAL(19, 3)
	SET @amount6 = 0.888133
	PRINT @amount6


--**********************************************************

--#3
	--Describe what is happening
	--Run at the same time, compare

	DECLARE @name AS VARCHAR(10)
	SET @name = 'Dave'
	PRINT @name
	SELECT DATALENGTH(@name)

	DECLARE @name1 AS CHAR(10)
	SET @name1 = 'Dave'
	PRINT @name1
	SELECT DATALENGTH(@name1)

--*****************************************************

--#4

--Run one at a time

	SELECT SUBSTRING('Microsoft SQL Server',11,3);
	SELECT LEFT('Microsoft SQL Server',9);
	SELECT RIGHT('Microsoft SQL Server',6);
	SELECT LEN('Microsoft SQL Server     ');
	SELECT DATALENGTH('Microsoft SQL Server     ');
	SELECT CHARINDEX('SQL','Microsoft SQL Server');
	SELECT REPLACE('Microsoft SQL Server Denali','Denali','2012');
	SELECT UPPER('Microsoft SQL Server');
	SELECT LOWER('Microsoft SQL Server');

--********************************************************************

--#5
	--Will dump the time
	DECLARE @bdate DATE
	SET @bdate = '01/01/1965 01:00:00'
	PRINT @bdate

	--Note time
	DECLARE @bday DATETIME
	SET @bday = '01/01/1965'
	PRINT @bday

	--Note Date
	DECLARE @bday1 DATETIME
	SET @bday1 = '01:00:00'
	PRINT @bday1
	--Importance of using the proper data type

	CREATE TABLE #datetest
			(dateexample  VARCHAR(20),
			 DateproperDT DATE)

	INSERT #datetest
		(dateexample, DateproperDT)
	VALUES    ('1/02/2018' , '01/02/2018')
			, ('2/02/2018' , '02/02/2018')
			, ('12/03/2018', '03/02/2018')
			, ('4/02/2018' , '04/02/2018')
			, ('5/02/2018' , '05/02/2018')
			, ('11/02/2018', '11/02/2018')
			, ('12/02/2018', '12/02/2018')

	SELECT *
	FROM #datetest
	ORDER BY dateexample ASC

	SELECT *
	FROM #datetest
	ORDER BY DATEProperDT ASC
--****************************************************

--#6


	SELECT
		GETDATE()			AS [GetDate],
		CURRENT_TIMESTAMP	AS [Current_Timestamp],
		GETUTCDATE()		AS [GetUTCDate],
		SYSDATETIME()		AS [SYSDateTime],
		SYSUTCDATETIME()	AS [SYSUTCDateTime],
		SYSDATETIMEOFFSET()	AS [SYSDateTimeOffset];

	SELECT DATENAME(MONTH,'02/02/2019');
	SELECT DAY('02/02/2019') AS [Day], MONTH('02/02/2019') AS [Month],YEAR('02/02/2019') AS [Year];

	SELECT DATETIMEFROMPARTS(2012,2,12,8,30,0,0) AS Result; --7 arguments
	SELECT DATETIME2FROMPARTS(2012,2,12,8,30,00,0,0) AS Result; -- 8 arguments
	SELECT DATEFROMPARTS(2012,2,12) AS Result; -- 3args



	SELECT DATEDIFF(d, '01/01/2017', GETDATE()) AS 'Day Different'
	
	SELECT DATEDIFF(MINUTE, '04/01/2019', GETDATE()) AS 'Minutes Different'

	SELECT DATEADD(d, 1, GETDATE())

	SELECT DATEADD(d, -1, GETDATE())


--**************************************************************


--#7

	SELECT  1  +  2    AS result;

	SELECT '1' + '2'   AS result;

	SELECT  1  + '2'   AS result;

	SELECT  1  + 'abc' AS result;

--*********************************************************

--#8

	SELECT    c.name AS 'Column Name'
			, t.name
			, c.prec
			, c.xscale
			, y.name
			, t.name AS 'Table Name'
			, S.name AS 'Schema Name'
	FROM syscolumns c
		INNER JOIN sys.tables t
			ON c.id = t.object_id
		INNER JOIN sys.types y
			ON c.xtype = y.user_type_id 
		INNER JOIN SYS.schemas S
			ON t.schema_id = S.schema_id
	WHERE t.type = 'u'
		AND t.name = 'BillOfMaterials'